class TFStaticProp : Actor
{
	Default
	{
		+SOLID
	}
	
	override void Tick()
	{
		if (IsFrozen() || !CheckNoDelay()) return;

		if (tics != -1)
		{
			if (tics > 0)
				tics--;
	
			while (!tics)
				if (!SetState(CurState.NextState)) return;
		}
	}
}

class Bottle1 : FXBase_Inanimate
{
	Default
	{
		//$Category "Decorations/Props/Utensils"
		
		Radius 3;
		Height 16;
		Scale 0.6;

		-SOLID
	}

	States
	{
		Spawn:
			BTTL A -1;
			Stop;
	}
}

class Bottle2 : Bottle1
{
 	Default
	{
		//$Category "Decorations/Props/Utensils"
		
		Scale 0.5;
	}

	States
	{
		Spawn:
			BTTL B -1;
			Stop;
	}
}

class Glass : Bottle1
{
	Default
	{
		//$Category "Decorations/Props/Utensils"
		
		Height 16;
	}

	States
	{
		Spawn:
			GLSS A -1;
			Stop;
	}
}

class WoodBurner : TFStaticProp
{
	Default
	{
		//$Category "Decorations/Props/Furniture"
		
		Radius 10;
		Height 20;
	}

	States
	{
		Spawn:
			STV1 A -1;
			Stop;
	}
}

class Cup : Bottle1
{
	Default
	{
		//$Category "Decorations/Props/Utensils"
		
		Radius 3;
  		Height 8;
	}

	States
	{
		Spawn:
			FCUP A -1;
			Stop;
	}
}

class Chair : TFStaticProp
{
	Default
	{
		//$Category "Decorations/Props/Furniture"
		
		Radius 3;
  		Height 8;
		Scale 1.2;
	}

	States
	{
		Spawn:
			CHAW A -1;
			Stop;
	}
}

class Pot1 : Cup
{
	Default
	{
		//$Category "Decorations/Props/Furniture"
		
		Scale 0.8;
	}
  
	States
	{
		Spawn:
			POTD A -1;
			Stop;
	}
}

class Boot : Cup
{
	Default
	{
		//$Category "Decorations/Props/Equipment"
		
		Scale 1.1;
	}

	States
	{
		Spawn:
			BOOT A -1;
			Stop;
	}
}

class Helmet : Cup
{
	Default
	{
		//$Category "Decorations/Props/Equipment"
		
		Scale 1;
	}

	States
	{
		Spawn:
			HELT A -1;
			Stop;
	}
}

class CartA : TFStaticProp
{
	Default
	{
		//$Category Farmstuff
		
		Radius 25;
		Height 26;
	}

	States
	{
		Spawn:
			C0RT A -1;
			Stop;
	}
}

class WellBucket : FXBase_Inanimate
{
	Default
	{
		//$Category Farmstuff
		
		Radius 10;
		Height 60;
	}
    
	States
	{
		Spawn:
			WBKT A -1;
			Stop;
	}
}

class GreatEye : FXBase
{
	Default
	{
		//$Category zogvywnz
		
		Radius 10;
		Height 60;
		Scale 2;
		RenderStyle "add";
		Alpha 0.6;
	}
    
	States
	{
		Spawn:
			GEYE ABCDE 4 Bright;
			GEYE F 200 Bright;
			GEYE EDCBA 4 Bright;
			Stop;
	}
}

class WitchSpooker : FXBase
{
	Default
	{
		//$Category zogvywnz
		
		Radius 10;
		Height 60;
		Scale 0.7;
		RenderStyle "add";
		Alpha 0.0;
		
	}
    
	States
	{
		Spawn:
		    WTCH A 4 A_SetTranslucent (0.0, 0);
		    WTCH A 4 A_SetTranslucent (0.2, 0);
			WTCH A 4 A_SetTranslucent (0.4, 0);
			WTCH A 4 A_SetTranslucent (0.6, 0);
			WTCH A 4 A_SetTranslucent (0.8, 0);
			WTCH A 4 A_SetTranslucent (0.8, 0);
			WTCH ABCDEFGHI 6 ;
			WTCH I 2 A_SetTranslucent (0.8, 0);
			WTCH I 2 A_SetTranslucent (0.6, 0);
			WTCH I 2 A_SetTranslucent (0.4, 0);
			WTCH I 2 A_SetTranslucent (0.2, 0);
			WTCH I 2 A_SetTranslucent (0.0, 0);
			Stop;
	}
}

class FeverBitch : FXBase
{
	Default
	{
		//$Category zogvywnz
		
		Radius 10;
		Height 60;
		Scale 0.6;
		
		
	}
    
	States
	{
		Spawn:
		    BTCH A 4; 
		    BTCH BCDEF 8 ;
			
			Stop;
	}
}


class LostChild : FXBase
{
	Default
	{
		//$Category zogvywnz
		
		Radius 10;
		Height 60;
		Scale 0.7;
		RenderStyle "add";
		Alpha 0.0;
		
		}
    
	States
	{
		Spawn:
		    GCLD  A 10 A_SetTranslucent (0.0, 0);
		    GCLD  A 10 A_SetTranslucent (0.1, 0);
			GCLD  A 10 A_SetTranslucent (0.2, 0);
			GCLD  A 20 A_SetTranslucent (0.3, 0);
			GCLD  A 60 A_SetTranslucent (0.4, 0);
			GCLD  A 20 A_SetTranslucent (0.3, 0);
			GCLD  A 10 A_SetTranslucent (0.2, 0);
			GCLD  A 10 A_SetTranslucent (0.1, 0);
			loop;
	}
}

class Shade : TFStaticProp
{
	Default
	{
		//$Category MT
		
		Radius 25;
		Height 26;
		Scale 1.06;
	}

	States
	{
		Spawn:
			HORS A -1;
			Stop;
	}
}

//////CUTSCENE ACTORS////////////////


class MTMountedA : TFStaticProp
{
	Default
	{
		//$Category MT
		
		Radius 25;
		Height 26;
		Scale 1.06;
	}

	States
	{
		Spawn:
			MORS ABCB 7;
			LOOP;
	}
}

class MTMountedB : TFStaticProp
{
	Default
	{
		//$Category MT
		
		Radius 25;
		Height 26;
		Scale 1.06;
	}

	States
	{
		Spawn:
			MORS D -1 ;
			STOP;
	}
}

class MTMountedC : TFStaticProp
{
	Default
	{
		//$Category MT
		
		Radius 25;
		Height 26;
		Scale 1.06;
	}

	States
	{
		Spawn:
			MORS E -1 ;
			STOP;
	}
}

class MTDISMountedA : TFStaticProp
{
	Default
	{
		//$Category MT
		
		Radius 15;
		Height 16;
		Scale 1.06;
	}

	States
	{
		Spawn:
			MTOF A -1 ;
			STOP;
	}
}

class MTDISMountedB : TFStaticProp
{
	Default
	{
		//$Category MT
		
		Radius 15;
		Height 16;
		Scale 1.06;
	}

	States
	{
		Spawn:
			MTOF B -1 ;
			STOP;
	}
}

class OLDMANA : TFStaticProp
{
	Default
	{
		//$Category OLD
		
		Radius 15;
		Height 16;
		
	}

	States
	{
		Spawn:
			OMAN A -1  ;
			STOP;
	}
}

class OLDMANB : TFStaticProp
{
	Default
	{
		//$Category OLD
		
		Radius 15;
		Height 16;
		
	}

	States
	{
		Spawn:
			OMAN B -1  ;
			STOP;
	}
}

class OLDMANC : TFStaticProp
{
	Default
	{
		//$Category OLD
		
		Radius 15;
		Height 16;
		
	}

	States
	{
		Spawn:
			OMAN C -1  ;
			STOP;
	}
}

class OLDMAND : TFStaticProp
{
	Default
	{
		//$Category OLD
		
		Radius 15;
		Height 16;
		
	}

	States
	{
		Spawn:
			OMAN D -1  ;
			STOP;
	}
}

class MTPOSE : TFStaticProp
{
	Default
	{
		//$Category MT
		
		Radius 25;
		Height 26;
		Scale 1.06;
	}

	States
	{
		Spawn:
			MTSD ABCDEFEDCB 6;
			LOOP;
	}
}