class DripSpawner : FXBase
{
	Default
	{
		Radius 16;
		Height 1;
		
		+SPAWNCEILING
	}

	States
	{
		Spawn:
			TNT1 A 1 NoDelay
			{
				A_SetTics(Random[FX](7, 17));
				A_SpawnItemEx("Drip", Random[FX](-Radius, Radius), Random[FX](-Radius, Radius));
			}
			Loop;
	}
}

class Drip : FXBase_Gravity
{
    Default
	{
		Radius 1;
		Height 2;
		Scale 0.75;

		RenderStyle "Translucent";
		Alpha 0.8;
	}

	States
	{
		Spawn:
			RNDR A 1 NoDelay CheckImpact();
			Loop;
		Death:
			RNDR BCDEFGH 3;
			Stop;
	}
}

class BloodDripSpawner : DripSpawner
{
	Default
	{
		Radius 16;
		Height 1;
		
		+SPAWNCEILING
	}

	States
	{
		Spawn:
			TNT1 A 1 NoDelay
			{
				A_SetTics(Random[FX](7, 17));
				A_SpawnItemEx("BloodDrop", Random[FX](-Radius, Radius), Random[FX](-Radius, Radius));
			}
			Loop;
	}
}

class BloodDrop : Drip
{
	States
	{
		Spawn:
			BNDR A 1 NoDelay CheckImpact();
			Loop;
		Death:
			BNDR BCDEFGH 3;
			Stop;
	}
}

class TFLeafSpawner : FXBase
{
	Default
	{
		Radius 16;
		Height 1;
	}

	States
	{
		Spawn:
			TNT1 A 1 NoDelay
			{
				A_SetTics(Random[FX](10, 20));
				A_SpawnProjectile("TFLeaf", Random[FX](-Radius, Radius), Random[FX](-Radius, Radius), angle + Random[FX](-35, 35), pitch + Random[FX](-15, 15));
			}
			Loop;
	}
}

class TFLeaf : FXBase_Gravity
{
	int rotation;

	Default
	{
		Speed 3;
		Gravity 0.01;

		RenderStyle "Translucent";
		Alpha 0.0;

		+INTERPOLATEANGLES
		+FORCEXYBILLBOARD
		+ROLLSPRITE
	}

	override void PostBeginPlay()
	{
		super.PostBeginPlay();

		rotation = 45 + Random[FX](10, 25) * RandomPick[FX](-1, 1);
	}

	States
	{
		Spawn:
			LEF1 A 4
			{
				A_FadeIn(0.075);
				CheckImpact();
				roll += rotation;
			}
			Loop;
		Death:
			TNT1 A 1 A_FadeOut(0.05);
			Wait;
	}
}