class SmokingPiece : FXBase_Gravity
{
	Default
	{
		Speed 12;
		Gravity 0.7;

		+MISSILE
		-NOGRAVITY
	}

	States
	{
		Spawn:
			TNT1 A 1 NoDelay
			{
				CheckImpact();
				A_SpawnItem("SmokingPieceSmoke");
			}
			Wait;
	}
}

class SmokingPieceSmoke : ShotSmokeTrail
{
	Default
	{
		Scale 0.06;
		
		Alpha 0.5;
	}
}

class CraterSmoke : FXBase_Movement
{
	Default
	{
		Scale 0.5;
		Speed 1;
		
		RenderStyle "Add";
		Alpha 0.4;
	}
	
	States
	{
		Spawn:
			TNT1 A 3;
			SMCK ABCDE 16;
			Stop;
	}
}

class Rise_Smoker : FXBase_Movement
{
	States
	{
		Spawn:
			TNT1 AAAAAA 20 A_SpawnProjectile("CraterSmoke", 0, 0, Random[FX](0, 360), CMF_AIMDIRECTION, -Random[FX](60, 80));
			Stop;
	}
}

class Scorch_Crater : FXBase
{
	Default
	{
		Scale 3.4;
		
		Renderstyle "Translucent";
		Alpha 0.55;

		+FLATSPRITE
	}

    States
    {
		Spawn:
			XXX1 A 4000 NoDelay ThrustThingZ(0, -10, 0, 1);
			Stop;
    }
}

class BigScorch_Crater : Scorch_Crater
{
 	Default
	{
		Scale 4.4;
	}
}

class BlotSmoke : FXBase
{
	Default
	{
		Scale 2;
		RenderStyle "Translucent";
		Alpha 0.4;
	}

	override void PostBeginPlay()
	{
		super.PostBeginPlay();

		switch (Random[FX](1, 4))
		{
			case 1:
				SetStateLabel("Blot1");
				break;
			case 2:
				SetStateLabel("Blot2");
				break;
			case 3:
				SetStateLabel("Blot3");
				break;
			case 4:
				SetStateLabel("Blot4");
				break;
		}
	}

	States
	{
		Spawn:
			BLOT A 0;
		Blot1:
			BLOT A 4;
			BLOT BCDE 12 A_FadeOut(0.2);
			Stop;
		Blot2:
			BLOT F 4;
			BLOT GHIJ 12 A_FadeOut(0.2);
			Stop;
		Blot3:
			BLOT K 4;
			BLOT LMNO 12 A_FadeOut(0.2);
			Stop;
		Blot4:
			BLOT P 4;
			BLOT QRST 12 A_FadeOut(0.2);
			Stop;
	}
}

class BIGBlotSmoke : BlotSmoke
{
	Default
	{
		Scale 3;
	}
	
	States
	{
		Spawn:
			BLOT A 0;
		Blot1:
			BLOT A 6;
			BLOT BCDE 15 A_FadeOut(0.2);
			Stop;
		Blot2:
			BLOT F 6;
			BLOT GHIJ 15 A_FadeOut(0.2);
			Stop;
		Blot3:
			BLOT K 6;
			BLOT LMNO 15 A_FadeOut(0.2);
			Stop;
		Blot4:
			BLOT P 6;
			BLOT QRST 15 A_FadeOut(0.2);
			Stop;
  	}
}

class DEATHBlotSmoke : BlotSmoke
{
	Default
	{
		Scale 5;
	}
	
	States
	{
		Spawn:
			BLOT A 0;
		Blot1:
			BLOT A 6;
			BLOT BCDE 15 A_FadeOut(0.2);
			Stop;
		Blot2:
			BLOT F 6;
			BLOT GHIJ 15 A_FadeOut(0.2);
			Stop;
		Blot3:
			BLOT K 6;
			BLOT LMNO 15 A_FadeOut(0.2);
			Stop;
		Blot4:
			BLOT P 6;
			BLOT QRST 15 A_FadeOut(0.2);
			Stop;
  	}
}