class MuzzleFlash1 : FXBase
{
	States
	{
		Spawn:
			TNT1 A 3 Bright Light("MuzzleFlash");
			Stop;
	}
}

////// Particles  ///////

class BulletSpark : FXBase_Gravity
{
	Default
	{
		Health 4;
		Radius 3;
		Height 6;
		Speed 0.2;
		Mass 0;
		Gravity 1.5;
		Scale .032;

		RenderStyle "Add";
		Alpha 1.0;

		+FLOORCLIP
		+DONTSPLASH
		-NOGRAVITY
	}

	States
	{
		Spawn:
			BPUF ABCD 1 NoDelay
			{
				A_FadeOut(0.025);
				CheckImpact();
			}
			Loop;
		Death:
			BPUF D 1 A_FadeOut(0.05);
			Loop;
	}
}

////// Smoke  ///////

class GunSmoke : FXBase_Movement
{
	Default
	{
		Scale 0.14;
		
		RenderStyle "Add";
		Alpha 0.6;

		+NOBLOCKMAP
		+FLOORCLIP
	}

	States
	{
		Spawn:
			SMOK ABCDEFGHIJKLMNOPQ 1;
			Stop;
	}
}

class MGGunSmoke : GunSmoke
{
	Default
	{
		Alpha 0.1;
		Scale 0.18;
	}
}

class ShotGunSmoke : GunSmoke
{
	Default
	{
		Alpha 0.7;
		Scale 0.19;
	}

	States
	{
		Spawn:
			SMOK ABCDEFGHIJKLMNOPQ 3;
			Stop;
	}
}

class FballGunSmoke : ShotGunSmoke
{
	Default
	{	
		Alpha 0.7;
		Scale 0.30;
	}
}

class ShotSmoke : FXBase_Movement
{
	Default
	{	
		VSpeed 1;
		Scale 0.1;

		RenderStyle "Add";
		Alpha 0.3;

		+FORCEXYBILLBOARD
	}

	States
	{
		Spawn:
			SMOK ABCDEFGHIJKLMNOPQ 1 NoDelay A_SpawnItemEx("ShotSmokeTrail"); //A_FadeOut(0.01)
			Stop;
	}
}

class ShotSmokeTrail : ShotSmoke
{
	Default
	{
		VSpeed 0;
		
		Alpha 0.15;
	}

	States
	{
		Spawn:
			SMOK CDEFGHIJKLMNOPQ 1;
			Stop;
	}
}

class BigGunSmoke : FXBase_Movement
{
	Default
	{
		Speed 15;
		Projectile;
	}

    States
    {
		Spawn:
			SMOK ABCDEFGHIJKLMNOPQ 1;
			Stop;
    }
}

class MOLShotSmoke : FXBase_Movement
{
	Default
	{
		VSpeed 1;
		Speed 1;
		Scale 0.4;
		
		RenderStyle "Add";
		Alpha 0.6;
	}
	
	States
 	{
		Spawn:
			SMOG AABBCCDDEEFFGGHHIIJJKKLLMMNNOOPPQQRR 1 NoDelay A_FadeOut(0.005);
			Stop;
    }
}