//Parts of code taken from CheapActor by phantombeta

class FXBase_Inanimate : Actor
{
	Default
	{
		Radius 1;
		Height 1;

		FloatBobPhase 0;

		+MOVEWITHSECTOR
		+NOBLOCKMAP
		+NOINTERACTION
		+SYNCHRONIZED
	}

	override void Tick()
	{
		ChangeStatNum(STAT_STATIC);
	}
}

class FXBase : FXBase_Inanimate
{
	override void Tick()
	{
		if (IsFrozen() || !CheckNoDelay()) return;

		if (tics != -1)
		{
			if (tics > 0)
				tics--;
	
			while (!tics)
				if (!SetState(CurState.NextState)) return;
		}
	}
}

class FXBase_Movement : FXBase
{
	override void Tick()
	{
		super.Tick();

		if (!(vel ~== (0, 0, 0)))
		{
			let newPos = level.Vec3Offset(pos, vel);
            bool xyPosEqual = (newPos.xy ~== pos.xy);
 
            if (xyPosEqual && !(vel.z ~== 0))
			{
                Prev.z = pos.z;
                SetZ(Clamp(newPos.z, floorz, ceilingz));
            }
			else if (!xyPosEqual)
			{
                SetOrigin((newPos.xy, Clamp(newPos.z, floorz, ceilingz)), true);
			}
        }
	}

	void CheckImpact()
	{
		if (pos.z <= floorz)
		{
			vel = (0, 0, 0);
			SetStateLabel("Death");
		}
	}
}

class FXBase_Gravity : FXBase_Movement
{
	override void Tick()
	{
		super.Tick();

		vel.z -= gravity;
	}
}