class TFStatusBar : StatusBarScreen
{
	Font tfFont;

	override void Init()
	{
		Super.Init();

		tfFont = "IntermissionFont_Doom";
	}

	override void Draw(int state, double ticFrac)
	{
		super.Draw(state, ticFrac);
		
		if (state == HUD_StatusBar)
		{
			BeginStatusBar();
			DrawMainBar(ticFrac);
			DrawTFMap();
		}
		else if (state == HUD_Fullscreen)
		{
			BeginHUD();
			DrawFullscreenStuff(ticFrac);
			DrawTFMap();
		}
	}
	
	void DrawMainBar(double ticFrac)
	{
		DrawTFBaseHUD();
	}
	
	void DrawFullscreenStuff(double ticFrac)
	{
		DrawTFBaseHUD();
	}
	
	void DrawTFIcon(string icon, vector2 iconPos, vector2 iconScale = (2.25, 2.25), int flags = 0)
	{
		vector2 iconSize = StatusBarScreen.GetImageSize(icon);
		
		StatusBarScreen.DrawImage(icon, (iconPos.x + iconSize.x, iconPos.y), flags, scale: iconScale);
	}

	void DrawTFBaseHUD()
	{
		//health		
		DrawTFIcon("MEDIA0", (72, 1080));
		StatusBarScreen.DrawString(tfFont, FormatNumber(CPlayer.health), (130, 1010), scale: (1.25, 1.25));
		
		//armor
		DrawTFIcon("ARM1A0", (72, 1032));
		StatusBarScreen.DrawString(tfFont, FormatNumber(GetArmorAmount()), (130, 930), scale: (1.25, 1.25));

		//ammo
		if (CPlayer && CPlayer.readyWeapon)
		{
			if (CPlayer.readyWeapon.Ammo1)
			{
				DrawTFIcon(TexMan.GetName(CPlayer.readyWeapon.Ammo1.icon), (1880, 1070), iconScale: (4, 4));
				StatusBarScreen.DrawString(tfFont, FormatNumber(CPlayer.readyWeapon.Ammo1.Amount), (1666, 1010), scale: (1.25, 1.25));
				
				if (TFWeaponBase(CPlayer.readyWeapon))
				{
					let reserveAmmo = TFWeaponBase(CPlayer.readyWeapon).ammoReserve;

					if (reserveAmmo)
					{
						StatusBarScreen.DrawString(tfFont, "/", (1706, 1014), scale: (1.25, 1.25));
						StatusBarScreen.DrawString(tfFont, FormatNumber(reserveAmmo.Amount), (1750, 1010), scale: (1.25, 1.25));
					}
				}
			}
			
			if (CPlayer.readyWeapon.Ammo2)
			{
				DrawTFIcon(TexMan.GetName(CPlayer.readyWeapon.Ammo2.icon), (1856, 1028), iconScale: (4, 4));
				StatusBarScreen.DrawString(tfFont, FormatNumber(CPlayer.readyWeapon.Ammo2.Amount), (1756, 980), scale: (1.25, 1.25));
			}
		}
		
		//keys
		if (CPlayer)
		{
			bool locks[6];
			for (int i = 0; i < 6; i++) locks[i] = CPlayer.mo.CheckKeys(i + 1, false, true);
			
			if (locks[0]) DrawTFIcon("RKEYA0", (1708, 92));
			if (locks[1]) DrawTFIcon("BKEYA0", (1780, 92));
			if (locks[2]) DrawTFIcon("YKEYA0", (1852, 92));
			if (locks[3]) DrawTFIcon("RSKUA0", (1708, 156));
			if (locks[4]) DrawTFIcon("BSKUA0", (1780, 156));
			if (locks[5]) DrawTFIcon("YSKUA0", (1852, 156));
		}
	}

	void DrawTFMap()
	{
		if (MapHandler(EventHandler.Find("MapHandler")).mapActive)
		{
			StatusBarScreen.DrawImage("CSMap", (1920/2, 1080/2), scale: (0.5, 0.5));
		}
	}
}