class CleaverCultistA : CCNPC
{
	Default
	{
		Radius 20;
		Height 56;
		Health 50;
		Speed 10;

		MaxTargetRange 512;
		MeleeThreshold 256;
		MinMissileChance 128;
		
		PainChance 200;

		SeeSound "VSLKART";
		ActiveSound "VSLKART";
		PainSound "VAPAIN";
		DeathSound "VADEATH";

		Obituary "%o was hunted down by a Cultist.";
		HitObituary "%o was chopped up by a Cultist.";
	}
	
	States
	{		
		Spawn:
			VILA A 0;
		Idle:
			#### XY 10 A_Look();
			Loop;
		See:
			#### AABBCCDD 2 A_Chase();
			Loop;
		Melee:
			#### EE 4 A_FaceTarget();
			#### F 7 A_CustomMeleeAttack(15,"HIT","MISS");
			#### E 4;
			Goto See;
		Missile:
			#### E 12 A_FaceTarget();
			#### Z 6
			{
				A_SpawnProjectile("TFCleaver", spawnofs_xy: 4);
			}
			#### E 4;
			Goto See;
		Pain:
			#### G 4;
			#### G 4 A_Pain();
			Goto See;
		Death:
			#### H 6;
			#### I 12;
			#### J 6 A_Scream();
			#### K 5;
			#### L 5 A_NoBlocking();
			#### M 5 A_StartSound("BFALL");
			#### N -1;
			Stop;
		Pain.Kick:
			#### G 12;
			#### G 14 A_Pain();
			#### G 12;
			Goto See;
		Raise:
			#### ML 8;
			#### KJI 6;
			Goto See;
	}
}

class CleaverCultistB : CleaverCultistA
{
	States
	{
		Spawn:
			VILB A 0;
			Goto Idle;
	}
}


class CleaverCultistSilent : CleaverCultistA
{
	Default
	{
		
		Speed 11;

		SeeSound "VCACT";
		ActiveSound "VCACT";
		PainSound "VCPAIN";
		DeathSound "VCDEATH";

		
	}
}

class TFCleaver : Actor
{
	Default
	{
		DamageFunction (20);
		Radius 2;
		Height 2;
		Scale 0.75;
		Speed 30;
		FastSpeed 40;
		Gravity 0.8;
		Projectile;
	
		Decal "BulletChip";
		
		SeeSound "throw";
		DeathSound "HIT";
	}
	
    States
    {
		Spawn:
			CLVR ABCDEFGH 2 Bright { vel.z -= gravity; }
			Loop;
		Death:
			CLVR IJKL 2 ;
			Stop;
    }
}