class StarSpawnBoss : CCNPC
{
	Default
	{
		//$Category StarSpawn
			
		Health 2000;
		GibHealth 0;
		Speed 18;
		Radius 42;
		Height 82;
		Scale 0.7;
		Mass 500;
        
		MeleeRange 96;
		
		BloodColor "Black";

		SeeSound "bgsee";
		ActiveSound "bglook";
		PainSound "BGACT";
		DeathSound "bDeath";
		MeleeSound "BGAttck";
		RenderStyle "Translucent";
		Alpha 0.7;
        Species "DEMON";
		+NOPAIN
		+MISSILEMORE
		+FLOAT
		+FLOATBOB
		+NOCLIP
		+NOGRAVITY
		+NOTARGET
		+MTHRUSPECIES
        +THRUSPECIES
		
	}
	
    States 
	{ 
		Spawn:
			DSM1 A 3 A_Look();
			DSM1 AAA 0 A_SpawnItemEx("BigBlotSMOKE", -4, Random[FX](-10, 10), Random[FX](-80, 10), 0, Random[FX](-1, 1), Random[FX](-1, 1));
			DSM1 A 0 A_SpawnItemEx("BossSSpawnShadow");
			DSM1 B 3 A_Look(); 
			DSM1 AAA 0 A_SpawnItemEx("BigBlotSMOKE", -4, Random[FX](-10, 10), Random[FX](-80, 10), 0, Random[FX](-1, 1), Random[FX](-1, 1));
			DSM1 C 3 A_Look(); 
			DSM1 AAA 0 A_SpawnItemEx("BigBlotSMOKE", -4, Random[FX](-10, 10), Random[FX](-80, 10), 0, Random[FX](-1, 1), Random[FX](-1, 1));
			DSM1 A 0 A_SpawnItemEx("BossSSpawnShadow");
			DSM1 D 3 A_Look();
			DSM1 AAA 0 A_SpawnItemEx("BigBlotSMOKE", -4, Random[FX](-10, 10), Random[FX](-80, 10), 0, Random[FX](-1, 1), Random[FX](-1, 1));
			DSM1 C 3 A_Look();
			DSM1 AAA 0 A_SpawnItemEx("BigBlotSMOKE", -4, Random[FX](-10, 10), Random[FX](-80, 10), 0, Random[FX](-1, 1), Random[FX](-1, 1));
			DSM1 A 0 A_SpawnItemEx("BossSSpawnShadow");
			DSM1 B 3 A_Look();
			DSM1 AAA 0 A_SpawnItemEx("BigBlotSMOKE", -4, Random[FX](-10, 10), Random[FX](-80, 10), 0, Random[FX](-1, 1), Random[FX](-1, 1));
			Loop;
		See:
			DTM1 ABCD 2 A_StartSound("BGAttck", CHAN_BODY, CHANF_OVERLAP);
			DEM1 EFGHGF 2;
			DEM1 ABCDCB 2;
			DTM1 DCBA 2;
			Goto Chase;
		Chase:
			DSM1 A 3 A_Chase(); 
			DSM1 AAA 0 A_SpawnItemEx("BigBlotSMOKE", -4, Random[FX](-10, 10), Random[FX](-80, 10), 0, Random[FX](-1, 1), Random[FX](-1, 1));
			DSM1 A 0 A_SpawnItemEx("BossSSpawnShadow");
			DSM1 B 3 A_Chase(); 
			DSM1 AAA 0 A_SpawnItemEx("BigBlotSMOKE", -4, Random[FX](-10, 10), Random[FX](-80, 10), 0, Random[FX](-1, 1), Random[FX](-1, 1));
			DSM1 A 0 A_SpawnItemEx("BossSSpawnShadow");
			DSM1 C 3 A_Chase(); 
			DSM1 AAA 0 A_SpawnItemEx("BigBlotSMOKE", -4, Random[FX](-10, 10), Random[FX](-80, 10), 0, Random[FX](-1, 1), Random[FX](-1, 1));
			DSM1 B 0 A_StartSound("BGACT", CHAN_BODY, CHANF_OVERLAP);
			DSM1 A 0 A_SpawnItemEx("BossSSpawnShadow");
			DSM1 D 3 A_Chase(); 
			DSM1 AAA 0 A_SpawnItemEx("BigBlotSMOKE", -4, Random[FX](-10, 10), Random[FX](-80, 10), 0, Random[FX](-1, 1), Random[FX](-1, 1));
			DSM1 A 0 A_SpawnItemEx("BossSSpawnShadow");
			DSM1 C 3 A_Chase(); 
			DSM1 AAA 0 A_SpawnItemEx("BigBlotSMOKE", -4, Random[FX](-10, 10), Random[FX](-80, 10), 0, Random[FX](-1, 1), Random[FX](-1, 1));
			DSM1 A 0 A_SpawnItemEx("BossSSpawnShadow");
			DSM1 B 3  A_Chase(); 
			DSM1 AAA 0 A_SpawnItemEx("BigBlotSMOKE", -4, Random[FX](-10, 10), Random[FX](-80, 10), 0, Random[FX](-1, 1), Random[FX](-1, 1));
			DSM1 A 0 A_SpawnItemEx("BossSSpawnShadow");
			Loop;
		Melee:
			DTM1 ABCD 2 A_FaceTarget();
			DEM1 B 0 A_StartSound("BGAttck", CHAN_BODY, CHANF_OVERLAP);
			DEM1 EFGHGF 2 A_CustomMeleeattack(10);
			DTM1 DCBA 2;
			Goto Chase;
		Missile:
			DTM1 ABCD 2;
			DEM1 ABCDCB 2 A_StartSound("BGAttck", CHAN_BODY, CHANF_OVERLAP);
			DEM1 B 0
			{
				A_FaceTarget();
				A_SpawnProjectile("DemonicStar", 24, 0, 0, CMF_AIMDIRECTION);
				A_SpawnProjectile("DemonicStar", 24, 0, -8, CMF_AIMDIRECTION);
				A_SpawnProjectile("DemonicBossStar", 24, 0, -8, CMF_AIMDIRECTION);
			}
			DEM1 EFGHGF 2 A_SpawnProjectile("DemonicStar", 24, 0, 8, CMF_AIMDIRECTION);
			
			DTM1 DCBA 2;
			Goto Chase;
		Death:
			DEM1 I 4
			{
				NashGoreGibs.SpawnGibs(self);
			}
			DEM1 AAA 0 A_SpawnItemEx("BlotSMOKE", -4, Random[FX](-10, 10), Random[FX](-80, 10), 0, Random[FX](-1, 1), Random[FX](-1, 1));
			DEM1 J 5 A_Scream();
			DEM1 AAA 0 A_SpawnItemEx("BigBlotSMOKE", -4, Random[FX](-10, 10), Random[FX](-80, 10), 0, Random[FX](-1, 1), Random[FX](-1, 1));
			DEM1 K 5 A_SetTranslucent(0.4, 0);
			DEM1 AAA 0 A_SpawnItemEx("BigBlotSMOKE", -4, Random[FX](-10, 10), Random[FX](-80, 10), 0, Random[FX](-1, 1), Random[FX](-1, 1));
			DEM1 L 5;
			DEM1 AAA 0 A_SpawnItemEx("BigBlotSMOKE", -4, Random[FX](-10, 10), Random[FX](-80, 10), 0, Random[FX](-1, 1), Random[FX](-1, 1));
			DEM1 I 5 ;  
			DEM1 AAA 0 A_SpawnItemEx("BigBlotSMOKE", -4, Random[FX](-10, 10), Random[FX](-80, 10), 0, Random[FX](-1, 1), Random[FX](-1, 1));
			DEM1 J 5;  
			DEM1 AAA 0 A_SpawnItemEx("BigBlotSMOKE", -4, Random[FX](-10, 10), Random[FX](-80, 10), 0, Random[FX](-1, 1), Random[FX](-1, 1));
			DEM1 K 5 A_SetTranslucent(0.3, 0);
			DEM1 AAA 0 A_SpawnItemEx("BigBlotSMOKE", -4, Random[FX](-10, 10), Random[FX](-80, 10), 0, Random[FX](-1, 1), Random[FX](-1, 1));
			DEM1 L 5; 
			DEM1 AAA 0 A_SpawnItemEx("BigBlotSMOKE", -4, Random[FX](-10, 10), Random[FX](-80, 10), 0, Random[FX](-1, 1), Random[FX](-1, 1));
			DEM1 K 5 A_SetTranslucent(0.2, 0);
			DEM1 AAA 0 A_SpawnItemEx("BigBlotSMOKE", -4, Random[FX](-10, 10), Random[FX](-80, 10), 0, Random[FX](-1, 1), Random[FX](-1, 1));
			DEM1 L 5 ;
			DEM1 AAA 0 A_SpawnItemEx("BigBlotSMOKE", -4, Random[FX](-10, 10), Random[FX](-80, 10), 0, Random[FX](-1, 1), Random[FX](-1, 1));
			DEM1 J 5 ;
			TNT1 A 0
			{
				for (int i = 0; i < 32; i++)	
					A_SpawnItemEx("BigBlotSMOKE", -4, Random[FX](-10, 10), Random[FX](-10, 10), 0, Random[FX](-1, 1), Random[FX](-1, 1));
			}
			DEM1 AAA 0 A_SpawnItemEx("BigBlotSMOKE", -4, Random[FX](-10, 10), Random[FX](-80, 10), 0, Random[FX](-1, 1), Random[FX](-1, 1));
			DEM1 I 5 A_SetTranslucent(0.1, 0);
			DEM1 AAA 0 A_SpawnItemEx("BigBlotSMOKE", -4, Random[FX](-10, 10), Random[FX](-80, 10), 0, Random[FX](-1, 1), Random[FX](-1, 1));
			Stop;
   	}
}

class DemonicStar : Actor
{
	Default
	{
		DamageFunction (10);
		Radius 4;
		Height 4;
		Speed 11;
		FastSpeed 19;
		Projectile;

		RenderStyle "Add";
		Alpha 0.8;
        Species "DEMON";
		SeeSound "Crack/see";
		DeathSound "Crack/death";

		+ROLLSPRITE
		+MTHRUSPECIES
        +THRUSPECIES
		
		
	}

    States
    {
		Spawn:
			PYB5 AAABBBCCC 1 Bright A_SpawnItemEx("StarTrail");
			Loop;
		Death:
			PYB5 DEF 6 Bright;
			Stop;
    }
}

class DemonicBossStar : Actor
{
	Default
	{
		DamageFunction (10);
		Radius 6;
		Height 6;
		Speed 14;
		FastSpeed 18;
		Projectile;
		Scale 1.2;

		RenderStyle "Add";
		Alpha 0.8;
        Species "DEMON";
		SeeSound "Crack/see";
		DeathSound "Crack/death";

		+ROLLSPRITE
		+SEEKERMISSILE 
		+MTHRUSPECIES
        +THRUSPECIES
	}

    States
    {
		Spawn:
			PYB5 AAABBBCCC 1 Bright A_SeekerMissile(2,4);
			PYB5 AAABBBCCC 1 Bright A_SpawnItemEx("StarTrail");
			Loop;
		Death:
			PYB5 DEF 6 Bright;
			Stop;
    }
}

class StarTrail : FXBase
{
    Default
	{
		RenderStyle "Add";
		Alpha 0.5;
	}

    States
    {
		Spawn:
			PYB5 AB 2 Bright A_FadeOut(0.1);
			Loop;
    }
}

class BossSSpawnShadow : FXBase
{
	Default
	{
		Scale 0.6;

		RenderStyle "Translucent";
		Alpha 0.3;
		
		+FORCEXYBILLBOARD
	}

	States
	{
		Spawn:
			DSM1 ABCDCBABCD 10 A_FadeOut(0.06);
			Stop;
	}
}