class MasterTemplar : PlayerPawn
{
	Default
	{
		Scale 1.06;
		Species "Ally";
		
		Player.AttackZOffset 13;

		Player.ForwardMove 0.75, 0.625;
		Player.SideMove 0.75, 0.625;
		Player.ViewBob 0.4;
		
		Player.DisplayName "MasterTemplar";
		Player.CrouchSprite "PLYC";
	
		Player.StartItem "Revolver";
		Player.StartItem "Shortsword";
		Player.StartItem "Bullets", 6;
		Player.StartItem "BulletClip", 12;
		Player.StartItem "ShellPack", 0;
		Player.StartItem "TemplarChestplate";
		
		
		Player.WeaponSlot 1, "Shortsword";
		Player.WeaponSlot 2, "Revolver";
		Player.WeaponSlot 3, "Trenchgun";

		+THRUSPECIES
	}

	override void HandleMovement()
	{
		super.HandleMovement();

		if (player.onground && !(player.cmd.forwardmove || player.cmd.sidemove) && vel.length() < 4)
		{
			vel.xy *= 0.9;
		}
	}

	override void FireWeapon(State stat)
	{
		let player = self.player;
		let weapn = player.ReadyWeapon;

		if (weapn == null) return;

		if (weapn.Ammo1 && !weapn.Ammo1.Amount)
		{
			if (CountInv(TFWeaponBase(weapn).ammoReserveType) && TFWeaponBase(weapn).bReloadable)
			{
				player.SetPSprite(PSP_WEAPON, weapn.FindState("Reload"));
			}
			
			return;
		}

		player.WeaponState &= ~WF_WEAPONBOBBING;
		PlayAttacking();
		weapn.bAltFire = false;
		if (stat == null)
		{
			stat = weapn.GetAtkState(!!player.refire);
		}
		player.SetPSprite(PSP_WEAPON, stat);
		if (!weapn.bNoAlert)
		{
			SoundAlert(self, false);
		}
	}

	void SetPlayerSprite()
	{
		if (PlayerNumber() != Net_Arbitrator)
		{
			sprite = GetSpriteIndex("TOSS");
			CrouchSprite = -1;
		}
	}

	States
	{
		Cache:
			PLAY A 0;
			TOSS A 0;

		Spawn:
			PLAY A -1 NoDelay SetPlayerSprite();
			Loop;
		See:
			#### ABCD 4;
			Loop;
		Missile:
			#### E 12;
			Goto Spawn;
		Melee:
			#### F 6 Bright;
			Goto Missile;
		Pain:
			#### G 4;
			#### G 4 A_Pain();
			Goto Spawn;
		Death:
			#### H 10;
			#### I 10 A_PlayerScream();
			#### J 10 A_NoBlocking();
			#### KLM 10;
			#### N -1;
			Stop;
		XDeath:
			#### O 5;
			#### P 5 A_XScream();
			#### Q 5 A_NoBlocking();
			#### RSTUV 5;
			#### W -1;
			Stop;
	}
}