class Revolver : TFWeaponBase Replaces Pistol
{
	Default
	{
		Scale 0.6;
		
		Weapon.SelectionOrder 6;
		
		Weapon.AmmoType "Bullets";
		TFWeaponBase.AmmoReserveType "BulletClip";
		Weapon.AmmoUse 1;
		TFWeaponBase.AmmoGiveReserve 6;

		TFWeaponBase.ReloadSpeed 40;
		
		Weapon.BobStyle "InverseSmooth";
		Weapon.BobSpeed 2.2;
		Weapon.BobRangeY 0.5;
		Weapon.BobRangeX 0.7;
		
		Inventory.Pickupmessage "You got the revolver!";
		Inventory.PickupSound "REVOPIK";
		
		Decal "BulletChip";
	}
	
	States
	{
		Spawn:
			HGUN C -1;
			Stop;
		Deselect:
			REVG A 1 A_Lower(18);
			Loop;
		Select:
			REVG A 1 A_Raise(18);
			Loop;
		Ready:
			REVG A 1 A_TFWeaponReady();
			Loop;
		Fire:
			REVG B 1 Bright
			{
				A_FireBullets(1, 1, -1, 18, "TFBulletPuff", FBF_NORANDOM | FBF_USEAMMO);

				A_StartSound("REVOFIR", CHAN_WEAPON, CHANF_OVERLAP);
				A_AlertMonsters();
				
				A_FireProjectile("YellowFlareSmallB", useammo: false);
				A_SpawnItemEx("GunSmoke", 24, zofs: height - 16);
				A_SpawnItemEx("MuzzleFlash1", 40, 0, 35);
			}
			REVG C 1 Bright;
			REVG D 1 Offset(0, 38);
			REVG E 1 Offset(0, 44);
			REVG E 1 Offset(0, 56);
			REVG E 1 Offset(0, 52) A_AlertMonsters();
			REVG D 1 Offset(0, 50);
			REVG D 1 Offset(0, 47);
			REVG D 1 Offset(0, 44);
			REVG A 1 Offset(0, 40);
			REVG A 1 Offset(0, 36);
			REVG A 1 Offset(0, 34);
			REVG A 1 Offset(0, 33);
			REVG A 1 Offset(0, 32);
			Goto Ready;
		Reload:
			REVG AAAA 1 A_WeaponOffset(0, 20, WOF_ADD);
			REVG A 0 A_StartSound("REVOPEN");
			REVG AAAAAAAAAAA 1;
		ReloadLoop:
			REVG A 6
			{
				A_StartSound("REVINSR");
				A_ReloadPrimary(instant: false);

				if (invoker.Ammo1.Amount == invoker.Ammo1.MaxAmount || !invoker.ammoReserve.Amount)
				{
					SetWeaponState("ReloadEnd");
					return;
				}
			}
			Loop;
		ReloadEnd:
			REVG AAAAAAAAAAA 1;
			REVG A 10
			{
				A_StartSound("REVSHUT");
			}
			REVG AAAA 1 A_WeaponOffset(0, -20, WOF_ADD);
			Goto Ready;
	}
}