class Trenchgun : TFWeaponBase Replaces Shotgun
{
    Default
	{
		Weapon.KickBack 50;
		
		Weapon.AmmoType "Shotshell";
		TFWeaponBase.AmmoReserveType "ShellPack";
		Weapon.AmmoUse 1;
		TFWeaponBase.AmmoGiveReserve 1;
	
		Weapon.BobStyle "InverseSmooth";
		Weapon.BobSpeed 1.8;
		Weapon.BobRangeY 0.4;
		Weapon.BobRangeX 0.6;
		
		Scale 0.7;

		Inventory.PickupSound "GRLLOG";
		Inventory.PickupMessage "Picked up a Trenchgun.";

		Decal "BulletChip";
	}

    States
    {
      	Spawn:
			WSRN A -1;
			Loop;
		Deselect:
			WSTG A 1 A_Lower(18);
			Loop;
		Select:
			WSTG A 1 A_Raise(18);
			Loop;
		Ready:
			WSTG A 1 A_TFWeaponReady();
			Loop;
		Fire:
			WSF2 A 1 Bright
			{
				A_FireBullets(6, 6, 18, 4, "TFBulletPuff", FBF_NORANDOM | FBF_USEAMMO);
				
				A_StartSound("ATKTRCH", CHAN_WEAPON, CHANF_OVERLAP);
				A_AlertMonsters();
				
				A_FireProjectile("YellowFlareSmallB", useammo: false);
				A_SpawnItemEx("GunSmoke", 24, zofs: height - 16);
				A_SpawnItemEx("ShotgunSmoke", 24, zofs: height - 16);
				A_SpawnItemEx("Muzzleflash1", 40, 0, 35);
				A_GunFlash();
			}
			WSF2 B 1 Bright Offset(0, 38)
			{
				A_SetPitch(pitch - 0.8, SPF_INTERPOLATE);
				A_SetAngle(angle - FRandom[Recoil](-1.5, 1.5), SPF_INTERPOLATE);
			}
			WSTG B 0 A_TFJumpIfNoAmmo("NoAmmo");
			Goto Reload;
		NoAmmo:
			WSTG BC 2 A_SetPitch(pitch - 0.8, SPF_INTERPOLATE);
			WSTG DCB 3;
			WSTG A 2;
			Goto Ready;
		Flash:
			WSTF AB 1 Bright;
			Stop;
		Reload:
			WSTG B 1 A_SetPitch(pitch - 0.8, SPF_INTERPOLATE);
			WSTG CD 2;
			WSTG E 0 A_StartSound("GRLLOG", CHAN_WEAPON, CHANF_OVERLAP);
			WSTG E 2;
			WSTG F 3;
			WSTG GHI 2;
			WSTG J 2 A_ReloadPrimary();
			WSTG K 2;
			WSTG LM 2;
			WSTG NOPQRS 2;
			Goto Ready;
	}
}